package mmkurssit;

import java.io.OutputStream;
import apumetodit.RandomNumero;
import java.io.PrintStream;

/**
 * - kopioi CRC-kortin vastuut tähän
 * @author aichinos
 * @version 25 Feb 2025
 *
 */
public class Kurssi {

    private int kurssiID = 0;
    private String nimi = "";
    private String opeSukunimi = "";
    private String opeEtunimi = "";
    
    private static int nextID = 1; // static = riippumatta olion olemassa olosta, atribuutti syntyy
                                        //          kun ohjelma käynistyy
                                        //        = yhteinen attribuutti koko luokassa
//=========================================================    
    
    /**
     * Kurssin alustuts
     */
    public Kurssi() {
        //
    }
    
    
    /**
     * Tulostetaan kurssin tiedot
     * @param os teitovirta johon tulostetaan 
     */
    public void tulosta(OutputStream os) {
        //tulsota(new PrintStream(os));
    }
    
    
    /**
     * Tulostetaan kurssin tiedot
     * @param out tietovirta johon tulostetaan
     */
    public void tulosta(PrintStream out) {
        out.println(String.format("Course ID: %03d", kurssiID) + " " + nimi);
                        //"%03d" = aina vähintään 3 numeroa, jos se ei täytä 3 numeroa niin 0:lla täytä
                        // sama tulostuu ("Course ID: ") + String.format("%03d", kurssiID)+ ---
        out.println(openNimet());
    }
    
    
    /**
     * Palauttaa kurssin tunnusnumeron.
     * @return kurssin tunnusnumero
     */
    public int getID() {
        return this.kurssiID;
    }
    
    
    /**
     * @return kurssin nimi
     */
    public String getNimi() {
        return this.nimi;
    }
    
    
    /**
     * @return kurssin opettajan sukunimi + etunimi
     */
    public String openNimet() {
        return this.opeSukunimi + " " + this.opeEtunimi;
    }
    
    
    /**
     * Antaa kurssille seuraavan tunnusnumeron
     * @example
     * <pre name="test">
     *    Kurssi saksa = new Kurssi();
     *      saksa.getID() === 0;
     *      saksa.rekisteroi();
     *    Kurssi ohjelmointi = new Kurssi();
     *      ohjelmointi.rekisteroi();
     *    int n1 = saksa.getID();
     *    int n2 = ohjelmointi.getID();
     *    n1 === 1;
     *    n2 === 2;
     * </pre>
     */
    public void rekisteroi() {
        this.kurssiID = nextID;
        nextID++;
    }
    
    
    /**
     * Apumetodi, jolla saadaan täytettyä testiarvot kurssille.
     * TODO: POISTA, kun kaikki toimii!!
     * 
     */
    void tayta() {
        this.nimi = "Ohjelmointi 2, nro: " + RandomNumero.rand(1,100);
        this.opeEtunimi = "Vesa";
        this.opeSukunimi = "Kokko";
        
    }
    
    //MAIN========================================================
    
    /**
     * @param args ei käytössä
     */
    public static void main(String[] args) {
    // luento 24.2.2025
    // Käytetään fxMMKurssi-mainissa oleva main koko ohjelmaa varten, mutta Java sallii,
    //että ohjelman sisällä tavallaan monta main-methodia.
        System.out.println(nextID);
        System.out.println("--------------");
        
        Kurssi ohjelmointi1 = new Kurssi();
        ohjelmointi1.rekisteroi();
        ohjelmointi1.tulosta(System.out);//tulostetaan ilman mitään täytetty tietoa
       
        ohjelmointi1.tayta();
        ohjelmointi1.tulosta(System.out);
        
        System.out.println("-------------------");
        
        Kurssi ohjelmointi2 = new Kurssi();
        ohjelmointi2.rekisteroi();
        ohjelmointi2.tulosta(System.out);
        
        ohjelmointi2.tayta();
        ohjelmointi2.tulosta(System.out);
        
        System.out.println("NextID on: " + nextID);
    }

    
    


    

}
